import greenfoot.*;  // (World, Actor, GreenfootImage, and Greenfoot)
import java.awt.Color;
/**
 * Write a description of class MyWorld here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class MyWorld extends World
{

    public static nyawa nyawa = new nyawa();
    public static nyawa nyawa1 = new nyawa();
    public static nyawa nyawa2 = new nyawa();
    
    private static final GreenfootImage bgImage = new GreenfootImage("back.png"); 
    private static final int scrollSpeed = 2; 

    private GreenfootImage scrollingImage; 
    private int scrollPosition = 0; 
    private GreenfootSound music = new GreenfootSound("background.mp3");
    private ScoreImage scoreCounter;
   

    public MyWorld()
    {    
        super(1000, 550, 1); 
        
        scrollingImage = getScrollingImage(1000, 550); 

        addObject (new Bird(), 60, 200); 

        int nEnemy = (Greenfoot.getRandomNumber(2))+1;
        addEnemy(nEnemy);
        
        addKoin(2);

        scoreCounter = new ScoreImage("Score: ");
        addObject(scoreCounter, 60, 30);
        addObject(nyawa, getWidth()/2-60,60);
        addObject(nyawa1,getWidth()/2, 60);
        addObject(nyawa2,getWidth()/2+60, 60);        

        GreenfootImage bg = getBackground();

        bg.setColor(Color.black);

        bg.drawString("BurungMu",700,30);
                     
        this.bgMusicStarted();
        prepare();
    }
    
public void act() 
    { 
        
       
        if ( Greenfoot.getRandomNumber(200) == 0)
        {
            addTruck(2);
            addKoin(1);
        }
        
        if ( Greenfoot.getRandomNumber(2000) == 0)
        {

            addKoin(3);
        }
        
        if(scrollPosition < 0) 
        { 
            scrollPosition = getWidth();
        }
        
        scrollPosition -= scrollSpeed; 
        paint(scrollPosition);
    }
    
    public void bgMusicStarted()
    {
        music.playLoop();
    }
     
    public void bgMusicStopped()
    {
        music.stop();
    }
    
    public void addTruck(int number)
    {
        for(int k = 0; k < number; k++)
        {
            int x = Greenfoot.getRandomNumber (getWidth())+1;
            int y = getHeight()-50;
       
            addObject(new truck(),x,y);
        }
    }
    
    public void addEnemy(int number)
    {
        for(int k = 0; k < number; k++)
        {
            int x = Greenfoot.getRandomNumber (getWidth())+1;
            int y = Greenfoot.getRandomNumber (getHeight())+1;
            if(x<900){x=900+ Greenfoot.getRandomNumber (150);}
            if(y>getHeight()){y=getHeight()- Greenfoot.getRandomNumber (150);}
            addObject(new Enemy(),x,y);
        }
    }
    
    public void addKoin(int number)
    {
        for(int k = 0; k < number; k++)
        {
            int x = Greenfoot.getRandomNumber (getWidth())+1;
            int y = Greenfoot.getRandomNumber (getHeight())+1;
            addObject(new powerup(),x,y);
        }
    }
    

    
    /** 
      * Paint scrolling image at given position and make sure the rest of 
      * the background is also painted with the same image. 
    */ 
    
   private void paint(int position)
   { 
       GreenfootImage bg = getBackground(); 
       bg.drawImage(scrollingImage, position, 0); 
       if(position > 0) 
       { 
           bg.drawImage(scrollingImage, position - scrollingImage.getWidth(), 0);
       } 
       else 
       { 
           bg.drawImage(scrollingImage, position + scrollingImage.getWidth(), 0); 
       } 
   } 
   
   public void UpdateScore(int newScore) 
   {
       scoreCounter.add(newScore);
   }

   public ScoreImage getScoreImage()
   {
       return scoreCounter;
   }
   
   /** 
     * Returns an image with the given dimensions. 
     */ 
   private GreenfootImage getScrollingImage(int width, int height) 
   {
       GreenfootImage image = new GreenfootImage(width, height); 
       for(int x = 0; x < width; x += bgImage.getWidth())
       {
           for(int y = 0; y < height; y += bgImage.getHeight())
           {
               image.drawImage(bgImage, x, y); 
           } 
       }
       return image; 
    }

   /**
     * Prepare the world for the start of the program. That is: create the initial
     * objects and add them to the world.
   */
   private void prepare()
   {

   }
}